import{S as im,i as lm,s as cm,e as n,k as c,w as u,t as i,M as dm,c as a,d as o,m as d,a as r,x as g,h as l,b as s,N as C,f as am,G as e,g as p,y as _,q as v,o as b,B as w,v as fm,L as sm}from"../../../../chunks/vendor-hf-doc-builder.js";import{D as Y}from"../../../../chunks/Docstring-hf-doc-builder.js";import{C as ae}from"../../../../chunks/CodeBlock-hf-doc-builder.js";import{I as en}from"../../../../chunks/IconCopyLink-hf-doc-builder.js";import{E as rm}from"../../../../chunks/ExampleCodeBlock-hf-doc-builder.js";function pm(zt){let $,A,k,y,N;return y=new ae({props:{code:`# !pip install opencv-python transformers accelerate
from diffusers import StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
from diffusers.utils import load_image
import numpy as np
import torch

import cv2
from PIL import Image

# download an image
image = load_image(
    "https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png"
)
image = np.array(image)

# get canny image
image = cv2.Canny(image, 100, 200)
image = image[:, :, None]
image = np.concatenate([image, image, image], axis=2)
canny_image = Image.fromarray(image)

# load control net and stable diffusion v1-5
controlnet = ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)

# speed up diffusion process with faster scheduler and memory optimization
pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
# remove following line if xformers is not installed
pipe.enable_xformers_memory_efficient_attention()

pipe.enable_model_cpu_offload()

# generate image
generator = torch.manual_seed(0)
image = pipe(
    "futuristic-looking woman", num_inference_steps=20, generator=generator, image=canny_image
).images[0]`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># !pip install opencv-python transformers accelerate</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel, UniPCMultistepScheduler
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> cv2
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># download an image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = load_image(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png&quot;</span>
<span class="hljs-meta">... </span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = np.array(image)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># get canny image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>image = cv2.Canny(image, <span class="hljs-number">100</span>, <span class="hljs-number">200</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = image[:, :, <span class="hljs-literal">None</span>]
<span class="hljs-meta">&gt;&gt;&gt; </span>image = np.concatenate([image, image, image], axis=<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>canny_image = Image.fromarray(image)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># load control net and stable diffusion v1-5</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>controlnet = ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = StableDiffusionControlNetPipeline.from_pretrained(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
<span class="hljs-meta">... </span>)

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># speed up diffusion process with faster scheduler and memory optimization</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># remove following line if xformers is not installed</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention()

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_model_cpu_offload()

<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># generate image</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>generator = torch.manual_seed(<span class="hljs-number">0</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>image = pipe(
<span class="hljs-meta">... </span>    <span class="hljs-string">&quot;futuristic-looking woman&quot;</span>, num_inference_steps=<span class="hljs-number">20</span>, generator=generator, image=canny_image
<span class="hljs-meta">... </span>).images[<span class="hljs-number">0</span>]`}}),{c(){$=n("p"),A=i("Examples:"),k=c(),u(y.$$.fragment)},l(m){$=a(m,"P",{});var D=r($);A=l(D,"Examples:"),D.forEach(o),k=d(m),g(y.$$.fragment,m)},m(m,D){p(m,$,D),e($,A),p(m,k,D),_(y,m,D),N=!0},p:sm,i(m){N||(v(y.$$.fragment,m),N=!0)},o(m){b(y.$$.fragment,m),N=!1},d(m){m&&o($),m&&o(k),w(y,m)}}}function mm(zt){let $,A,k,y,N;return y=new ae({props:{code:`import torch
from diffusers import DiffusionPipeline
from xformers.ops import MemoryEfficientAttentionFlashAttentionOp

pipe = DiffusionPipeline.from_pretrained("stabilityai/stable-diffusion-2-1", torch_dtype=torch.float16)
pipe = pipe.to("cuda")
pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
# Workaround for not accepting attention shape using VAE for Flash Attention
pipe.vae.enable_xformers_memory_efficient_attention(attention_op=None)`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> torch
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> DiffusionPipeline
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> xformers.ops <span class="hljs-keyword">import</span> MemoryEfficientAttentionFlashAttentionOp

<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = DiffusionPipeline.from_pretrained(<span class="hljs-string">&quot;stabilityai/stable-diffusion-2-1&quot;</span>, torch_dtype=torch.float16)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe = pipe.to(<span class="hljs-string">&quot;cuda&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.enable_xformers_memory_efficient_attention(attention_op=MemoryEfficientAttentionFlashAttentionOp)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Workaround for not accepting attention shape using VAE for Flash Attention</span>
<span class="hljs-meta">&gt;&gt;&gt; </span>pipe.vae.enable_xformers_memory_efficient_attention(attention_op=<span class="hljs-literal">None</span>)`}}),{c(){$=n("p"),A=i("Examples:"),k=c(),u(y.$$.fragment)},l(m){$=a(m,"P",{});var D=r($);A=l(D,"Examples:"),D.forEach(o),k=d(m),g(y.$$.fragment,m)},m(m,D){p(m,$,D),e($,A),p(m,k,D),_(y,m,D),N=!0},p:sm,i(m){N||(v(y.$$.fragment,m),N=!0)},o(m){b(y.$$.fragment,m),N=!1},d(m){m&&o($),m&&o(k),w(y,m)}}}function hm(zt){let $,A,k,y,N,m,D,tn,es,Oa,Z,re,on,He,ts,nn,os,Ua,Ve,Be,ns,as,Ga,Rt,rs,Fa,Wt,ss,za,Ht,an,is,Ra,se,ls,Ke,cs,ds,Wa,Vt,fs,Ha,ie,rn,Ye,ps,ms,sn,Ze,hs,Va,J,le,ln,Je,us,cn,gs,Ba,ce,dn,Q,fn,_s,vs,pn,bs,ws,Bt,ys,Es,mn,X,hn,Qe,$s,ks,un,gn,Ps,Cs,Kt,Xe,Ds,Ka,ee,de,_n,et,xs,vn,Ns,Ya,fe,Ts,bn,Ss,As,Za,pe,wn,yn,En,Is,js,$n,Yt,tt,Ms,Zt,Ls,qs,Ja,me,Os,ot,Us,Gs,Qa,nt,Xa,Jt,Qt,td,er,z,Fs,kn,zs,Rs,Xt,Ws,Hs,tr,eo,Vs,or,at,nr,to,Bs,ar,rt,rr,oo,Ks,sr,st,ir,no,Ys,lr,ao,ro,od,cr,he,Zs,so,Js,Qs,dr,it,fr,ue,Xs,io,ei,ti,pr,lt,mr,lo,oi,hr,ct,ur,co,ni,gr,fo,po,nd,_r,ge,Pn,ai,ri,mo,si,vr,te,_e,Cn,dt,ii,Dn,li,br,R,ci,xn,di,fi,Nn,pi,mi,wr,ve,hi,ft,ui,gi,yr,oe,be,Tn,pt,_i,Sn,vi,Er,we,An,I,In,bi,wi,jn,yi,Ei,Mn,$i,ki,Ln,Pi,Ci,P,j,ye,mt,Di,xi,Ni,qn,Ti,Si,On,Ai,Ii,Un,ho,Ee,ad,ji,Gn,uo,go,rd,Mi,M,$e,ht,Li,qi,Oi,Fn,Ui,Gi,zn,Fi,zi,Rn,_o,vo,sd,Ri,Wn,bo,wo,id,Wi,L,ke,ut,Hi,Vi,Bi,Hn,Ki,Yi,Vn,Zi,Ji,Bn,yo,Eo,ld,Qi,Kn,$o,ko,cd,Xi,q,Pe,gt,el,tl,ol,Yn,nl,al,Zn,rl,sl,Jn,Po,Co,dd,il,Qn,Do,xo,fd,ll,O,Ce,_t,cl,dl,fl,Xn,pl,ml,vt,hl,bt,ul,gl,_l,ea,No,To,pd,vl,ta,So,Ao,md,bl,U,De,wt,wl,yl,El,oa,$l,kl,yt,Pl,Et,Cl,Dl,xl,na,Io,jo,hd,Nl,aa,Mo,Lo,ud,Tl,G,xe,$t,Sl,Al,Il,ra,jl,Ml,sa,Ll,ql,ia,qo,Oo,gd,Ol,la,Uo,Go,_d,Ul,F,kt,Pt,Gl,Fl,ca,zl,Rl,Ct,Wl,Dt,Hl,Vl,Bl,da,Fo,zo,vd,Kl,fa,Ro,Wo,bd,$r,h,xt,Yl,pa,Zl,Jl,Nt,Ql,Ho,Xl,ec,tc,W,Tt,oc,ma,nc,ac,Ne,rc,H,St,sc,ha,ic,lc,ua,cc,dc,Te,At,fc,It,pc,ga,mc,hc,uc,V,jt,gc,_a,_c,vc,va,bc,wc,Se,Mt,yc,Lt,Ec,ba,$c,kc,Pc,T,qt,Cc,wa,Dc,xc,ya,Nc,Tc,Ea,Sc,Ac,Ae,Ic,Ie,Ot,jc,$a,Mc,Lc,je,Ut,qc,S,Oc,ka,Uc,Gc,Pa,Fc,zc,Ca,Rc,Wc,Da,Hc,Vc,Bc,Me,Gt,Kc,ne,Yc,xa,Zc,Jc,Na,Qc,Xc,kr;return m=new en({}),He=new en({}),Je=new en({}),et=new en({}),nt=new ae({props:{code:`from diffusers import StableDiffusionControlNetPipeline
from diffusers.utils import load_image

# Let's load the popular vermeer image
image = load_image(
    "https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png"
)`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline
<span class="hljs-keyword">from</span> diffusers.utils <span class="hljs-keyword">import</span> load_image

<span class="hljs-comment"># Let&#x27;s load the popular vermeer image</span>
image = load_image(
    <span class="hljs-string">&quot;https://hf.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png&quot;</span>
)`}}),at=new ae({props:{code:"pip install opencv-contrib-python",highlighted:'pip <span class="hljs-keyword">install</span> opencv-contrib-python'}}),rt=new ae({props:{code:"pip install diffusers transformers git+https://github.com/huggingface/accelerate.git",highlighted:'pip install diffusers transformers git+https:<span class="hljs-regexp">//gi</span>thub.com<span class="hljs-regexp">/huggingface/</span>accelerate.git'}}),st=new ae({props:{code:`import cv2
from PIL import Image
import numpy as np

image = np.array(image)

low_threshold = 100
high_threshold = 200

image = cv2.Canny(image, low_threshold, high_threshold)
image = image[:, :, None]
image = np.concatenate([image, image, image], axis=2)
canny_image = Image.fromarray(image)`,highlighted:`<span class="hljs-keyword">import</span> cv2
<span class="hljs-keyword">from</span> PIL <span class="hljs-keyword">import</span> Image
<span class="hljs-keyword">import</span> numpy <span class="hljs-keyword">as</span> np

image = np.array(image)

low_threshold = <span class="hljs-number">100</span>
high_threshold = <span class="hljs-number">200</span>

image = cv2.Canny(image, low_threshold, high_threshold)
image = image[:, :, <span class="hljs-literal">None</span>]
image = np.concatenate([image, image, image], axis=<span class="hljs-number">2</span>)
canny_image = Image.fromarray(image)`}}),it=new ae({props:{code:`from diffusers import StableDiffusionControlNetPipeline, ControlNetModel
import torch

controlnet = ControlNetModel.from_pretrained("lllyasviel/sd-controlnet-canny", torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    "runwayml/stable-diffusion-v1-5", controlnet=controlnet, torch_dtype=torch.float16
)`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> StableDiffusionControlNetPipeline, ControlNetModel
<span class="hljs-keyword">import</span> torch

controlnet = ControlNetModel.from_pretrained(<span class="hljs-string">&quot;lllyasviel/sd-controlnet-canny&quot;</span>, torch_dtype=torch.float16)
pipe = StableDiffusionControlNetPipeline.from_pretrained(
    <span class="hljs-string">&quot;runwayml/stable-diffusion-v1-5&quot;</span>, controlnet=controlnet, torch_dtype=torch.float16
)`}}),lt=new ae({props:{code:`from diffusers import UniPCMultistepScheduler

pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

# this command loads the individual model components on GPU on-demand.
pipe.enable_model_cpu_offload()`,highlighted:`<span class="hljs-keyword">from</span> diffusers <span class="hljs-keyword">import</span> UniPCMultistepScheduler

pipe.scheduler = UniPCMultistepScheduler.from_config(pipe.scheduler.config)

<span class="hljs-comment"># this command loads the individual model components on GPU on-demand.</span>
pipe.enable_model_cpu_offload()`}}),ct=new ae({props:{code:`generator = torch.manual_seed(0)

out_image = pipe(
    "disco dancer with colorful lights", num_inference_steps=20, generator=generator, image=canny_image
).images[0]`,highlighted:`generator = torch.manual_seed(<span class="hljs-number">0</span>)

out_image = pipe(
    <span class="hljs-string">&quot;disco dancer with colorful lights&quot;</span>, num_inference_steps=<span class="hljs-number">20</span>, generator=generator, image=canny_image
).images[<span class="hljs-number">0</span>]`}}),dt=new en({}),pt=new en({}),xt=new Y({props:{name:"class diffusers.StableDiffusionControlNetPipeline",anchor:"diffusers.StableDiffusionControlNetPipeline",parameters:[{name:"vae",val:": AutoencoderKL"},{name:"text_encoder",val:": CLIPTextModel"},{name:"tokenizer",val:": CLIPTokenizer"},{name:"unet",val:": UNet2DConditionModel"},{name:"controlnet",val:": ControlNetModel"},{name:"scheduler",val:": KarrasDiffusionSchedulers"},{name:"safety_checker",val:": StableDiffusionSafetyChecker"},{name:"feature_extractor",val:": CLIPFeatureExtractor"},{name:"requires_safety_checker",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.vae",description:`<strong>vae</strong> (<a href="/docs/diffusers/v0.14.0/en/api/models#diffusers.AutoencoderKL">AutoencoderKL</a>) &#x2014;
Variational Auto-Encoder (VAE) Model to encode and decode images to and from latent representations.`,name:"vae"},{anchor:"diffusers.StableDiffusionControlNetPipeline.text_encoder",description:`<strong>text_encoder</strong> (<code>CLIPTextModel</code>) &#x2014;
Frozen text-encoder. Stable Diffusion uses the text portion of
<a href="https://huggingface.co/docs/transformers/model_doc/clip#transformers.CLIPTextModel" rel="nofollow">CLIP</a>, specifically
the <a href="https://huggingface.co/openai/clip-vit-large-patch14" rel="nofollow">clip-vit-large-patch14</a> variant.`,name:"text_encoder"},{anchor:"diffusers.StableDiffusionControlNetPipeline.tokenizer",description:`<strong>tokenizer</strong> (<code>CLIPTokenizer</code>) &#x2014;
Tokenizer of class
<a href="https://huggingface.co/docs/transformers/v4.21.0/en/model_doc/clip#transformers.CLIPTokenizer" rel="nofollow">CLIPTokenizer</a>.`,name:"tokenizer"},{anchor:"diffusers.StableDiffusionControlNetPipeline.unet",description:'<strong>unet</strong> (<a href="/docs/diffusers/v0.14.0/en/api/models#diffusers.UNet2DConditionModel">UNet2DConditionModel</a>) &#x2014; Conditional U-Net architecture to denoise the encoded image latents.',name:"unet"},{anchor:"diffusers.StableDiffusionControlNetPipeline.controlnet",description:`<strong>controlnet</strong> (<a href="/docs/diffusers/v0.14.0/en/api/models#diffusers.ControlNetModel">ControlNetModel</a>) &#x2014;
Provides additional conditioning to the unet during the denoising process`,name:"controlnet"},{anchor:"diffusers.StableDiffusionControlNetPipeline.scheduler",description:`<strong>scheduler</strong> (<a href="/docs/diffusers/v0.14.0/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a>) &#x2014;
A scheduler to be used in combination with <code>unet</code> to denoise the encoded image latents. Can be one of
<a href="/docs/diffusers/v0.14.0/en/api/schedulers/ddim#diffusers.DDIMScheduler">DDIMScheduler</a>, <a href="/docs/diffusers/v0.14.0/en/api/schedulers/lms_discrete#diffusers.LMSDiscreteScheduler">LMSDiscreteScheduler</a>, or <a href="/docs/diffusers/v0.14.0/en/api/schedulers/pndm#diffusers.PNDMScheduler">PNDMScheduler</a>.`,name:"scheduler"},{anchor:"diffusers.StableDiffusionControlNetPipeline.safety_checker",description:`<strong>safety_checker</strong> (<code>StableDiffusionSafetyChecker</code>) &#x2014;
Classification module that estimates whether generated images could be considered offensive or harmful.
Please, refer to the <a href="https://huggingface.co/runwayml/stable-diffusion-v1-5" rel="nofollow">model card</a> for details.`,name:"safety_checker"},{anchor:"diffusers.StableDiffusionControlNetPipeline.feature_extractor",description:`<strong>feature_extractor</strong> (<code>CLIPFeatureExtractor</code>) &#x2014;
Model that extracts features from generated images to be used as inputs for the <code>safety_checker</code>.`,name:"feature_extractor"}],source:"https://github.com/huggingface/diffusers/blob/v0.14.0/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L88"}}),Tt=new Y({props:{name:"__call__",anchor:"diffusers.StableDiffusionControlNetPipeline.__call__",parameters:[{name:"prompt",val:": typing.Union[str, typing.List[str]] = None"},{name:"image",val:": typing.Union[torch.FloatTensor, PIL.Image.Image, typing.List[torch.FloatTensor], typing.List[PIL.Image.Image]] = None"},{name:"height",val:": typing.Optional[int] = None"},{name:"width",val:": typing.Optional[int] = None"},{name:"num_inference_steps",val:": int = 50"},{name:"guidance_scale",val:": float = 7.5"},{name:"negative_prompt",val:": typing.Union[str, typing.List[str], NoneType] = None"},{name:"num_images_per_prompt",val:": typing.Optional[int] = 1"},{name:"eta",val:": float = 0.0"},{name:"generator",val:": typing.Union[torch._C.Generator, typing.List[torch._C.Generator], NoneType] = None"},{name:"latents",val:": typing.Optional[torch.FloatTensor] = None"},{name:"prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"negative_prompt_embeds",val:": typing.Optional[torch.FloatTensor] = None"},{name:"output_type",val:": typing.Optional[str] = 'pil'"},{name:"return_dict",val:": bool = True"},{name:"callback",val:": typing.Union[typing.Callable[[int, int, torch.FloatTensor], NoneType], NoneType] = None"},{name:"callback_steps",val:": int = 1"},{name:"cross_attention_kwargs",val:": typing.Union[typing.Dict[str, typing.Any], NoneType] = None"},{name:"controlnet_conditioning_scale",val:": float = 1.0"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.prompt",description:`<strong>prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts to guide the image generation. If not defined, one has to pass <code>prompt_embeds</code>.
instead.`,name:"prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.image",description:`<strong>image</strong> (<code>torch.FloatTensor</code>, <code>PIL.Image.Image</code>, <code>List[torch.FloatTensor]</code> or <code>List[PIL.Image.Image]</code>) &#x2014;
The ControlNet input condition. ControlNet uses this input condition to generate guidance to Unet. If
the type is specified as <code>Torch.FloatTensor</code>, it is passed to ControlNet as is. PIL.Image.Image\` can
also be accepted as an image. The control image is automatically resized to fit the output image.`,name:"image"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.height",description:`<strong>height</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The height in pixels of the generated image.`,name:"height"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.width",description:`<strong>width</strong> (<code>int</code>, <em>optional</em>, defaults to self.unet.config.sample_size * self.vae_scale_factor) &#x2014;
The width in pixels of the generated image.`,name:"width"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 50) &#x2014;
The number of denoising steps. More denoising steps usually lead to a higher quality image at the
expense of slower inference.`,name:"num_inference_steps"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.guidance_scale",description:`<strong>guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 7.5) &#x2014;
Guidance scale as defined in <a href="https://arxiv.org/abs/2207.12598" rel="nofollow">Classifier-Free Diffusion Guidance</a>.
<code>guidance_scale</code> is defined as <code>w</code> of equation 2. of <a href="https://arxiv.org/pdf/2205.11487.pdf" rel="nofollow">Imagen
Paper</a>. Guidance scale is enabled by setting <code>guidance_scale &gt; 1</code>. Higher guidance scale encourages to generate images that are closely linked to the text <code>prompt</code>,
usually at the expense of lower image quality.`,name:"guidance_scale"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.negative_prompt",description:`<strong>negative_prompt</strong> (<code>str</code> or <code>List[str]</code>, <em>optional</em>) &#x2014;
The prompt or prompts not to guide the image generation. If not defined, one has to pass
<code>negative_prompt_embeds</code>. instead. If not defined, one has to pass <code>negative_prompt_embeds</code>. instead.
Ignored when not using guidance (i.e., ignored if <code>guidance_scale</code> is less than <code>1</code>).`,name:"negative_prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.num_images_per_prompt",description:`<strong>num_images_per_prompt</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The number of images to generate per prompt.`,name:"num_images_per_prompt"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.eta",description:`<strong>eta</strong> (<code>float</code>, <em>optional</em>, defaults to 0.0) &#x2014;
Corresponds to parameter eta (&#x3B7;) in the DDIM paper: <a href="https://arxiv.org/abs/2010.02502" rel="nofollow">https://arxiv.org/abs/2010.02502</a>. Only applies to
<a href="/docs/diffusers/v0.14.0/en/api/schedulers/ddim#diffusers.DDIMScheduler">schedulers.DDIMScheduler</a>, will be ignored for others.`,name:"eta"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.generator",description:`<strong>generator</strong> (<code>torch.Generator</code> or <code>List[torch.Generator]</code>, <em>optional</em>) &#x2014;
One or a list of <a href="https://pytorch.org/docs/stable/generated/torch.Generator.html" rel="nofollow">torch generator(s)</a>
to make generation deterministic.`,name:"generator"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.latents",description:`<strong>latents</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated noisy latents, sampled from a Gaussian distribution, to be used as inputs for image
generation. Can be used to tweak the same generation with different prompts. If not provided, a latents
tensor will ge generated by sampling using the supplied random <code>generator</code>.`,name:"latents"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.prompt_embeds",description:`<strong>prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt weighting. If not
provided, text embeddings will be generated from <code>prompt</code> input argument.`,name:"prompt_embeds"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.negative_prompt_embeds",description:`<strong>negative_prompt_embeds</strong> (<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
Pre-generated negative text embeddings. Can be used to easily tweak text inputs, <em>e.g.</em> prompt
weighting. If not provided, negative_prompt_embeds will be generated from <code>negative_prompt</code> input
argument.`,name:"negative_prompt_embeds"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.output_type",description:`<strong>output_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;pil&quot;</code>) &#x2014;
The output format of the generate image. Choose between
<a href="https://pillow.readthedocs.io/en/stable/" rel="nofollow">PIL</a>: <code>PIL.Image.Image</code> or <code>np.array</code>.`,name:"output_type"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to return a <a href="/docs/diffusers/v0.14.0/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput">StableDiffusionPipelineOutput</a> instead of a
plain tuple.`,name:"return_dict"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.callback",description:`<strong>callback</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
A function that will be called every <code>callback_steps</code> steps during inference. The function will be
called with the following arguments: <code>callback(step: int, timestep: int, latents: torch.FloatTensor)</code>.`,name:"callback"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.callback_steps",description:`<strong>callback_steps</strong> (<code>int</code>, <em>optional</em>, defaults to 1) &#x2014;
The frequency at which the <code>callback</code> function will be called. If not specified, the callback will be
called at every step.`,name:"callback_steps"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.cross_attention_kwargs",description:`<strong>cross_attention_kwargs</strong> (<code>dict</code>, <em>optional</em>) &#x2014;
A kwargs dictionary that if specified is passed along to the <code>AttnProcessor</code> as defined under
<code>self.processor</code> in
<a href="https://github.com/huggingface/diffusers/blob/main/src/diffusers/models/cross_attention.py" rel="nofollow">diffusers.cross_attention</a>.`,name:"cross_attention_kwargs"},{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.controlnet_conditioning_scale",description:`<strong>controlnet_conditioning_scale</strong> (<code>float</code>, <em>optional</em>, defaults to 1.0) &#x2014;
The outputs of the controlnet are multiplied by <code>controlnet_conditioning_scale</code> before they are added
to the residual in the original unet.`,name:"controlnet_conditioning_scale"}],source:"https://github.com/huggingface/diffusers/blob/v0.14.0/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L574",returnDescription:`
<p><a
  href="/docs/diffusers/v0.14.0/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> if <code>return_dict</code> is True, otherwise a <code>tuple. When returning a tuple, the first element is a list with the generated images, and the second element is a list of </code>bool<code>s denoting whether the corresponding generated image likely represents "not-safe-for-work" (nsfw) content, according to the </code>safety_checker\`.</p>
`,returnType:`
<p><a
  href="/docs/diffusers/v0.14.0/en/api/pipelines/stable_diffusion/overview#diffusers.pipelines.stable_diffusion.StableDiffusionPipelineOutput"
>StableDiffusionPipelineOutput</a> or <code>tuple</code></p>
`}}),Ne=new rm({props:{anchor:"diffusers.StableDiffusionControlNetPipeline.__call__.example",$$slots:{default:[pm]},$$scope:{ctx:zt}}}),St=new Y({props:{name:"enable_attention_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_attention_slicing",parameters:[{name:"slice_size",val:": typing.Union[str, int, NoneType] = 'auto'"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_attention_slicing.slice_size",description:`<strong>slice_size</strong> (<code>str</code> or <code>int</code>, <em>optional</em>, defaults to <code>&quot;auto&quot;</code>) &#x2014;
When <code>&quot;auto&quot;</code>, halves the input to the attention heads, so attention will be computed in two steps. If
<code>&quot;max&quot;</code>, maxium amount of memory will be saved by running only one slice at a time. If a number is
provided, uses as many slices as <code>attention_head_dim // slice_size</code>. In this case, <code>attention_head_dim</code>
must be a multiple of <code>slice_size</code>.`,name:"slice_size"}],source:"https://github.com/huggingface/diffusers/blob/v0.14.0/src/diffusers/pipelines/pipeline_utils.py#L1107"}}),At=new Y({props:{name:"disable_attention_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_attention_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/v0.14.0/src/diffusers/pipelines/pipeline_utils.py#L1123"}}),jt=new Y({props:{name:"enable_vae_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/v0.14.0/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L163"}}),Mt=new Y({props:{name:"disable_vae_slicing",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_vae_slicing",parameters:[],source:"https://github.com/huggingface/diffusers/blob/v0.14.0/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L173"}}),qt=new Y({props:{name:"enable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention",parameters:[{name:"attention_op",val:": typing.Optional[typing.Callable] = None"}],parametersDescription:[{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention.attention_op",description:`<strong>attention_op</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Override the default <code>None</code> operator for use as <code>op</code> argument to the
<a href="https://facebookresearch.github.io/xformers/components/ops.html#xformers.ops.memory_efficient_attention" rel="nofollow"><code>memory_efficient_attention()</code></a>
function of xFormers.`,name:"attention_op"}],source:"https://github.com/huggingface/diffusers/blob/v0.14.0/src/diffusers/pipelines/pipeline_utils.py#L1050"}}),Ae=new rm({props:{anchor:"diffusers.StableDiffusionControlNetPipeline.enable_xformers_memory_efficient_attention.example",$$slots:{default:[mm]},$$scope:{ctx:zt}}}),Ot=new Y({props:{name:"disable_xformers_memory_efficient_attention",anchor:"diffusers.StableDiffusionControlNetPipeline.disable_xformers_memory_efficient_attention",parameters:[],source:"https://github.com/huggingface/diffusers/blob/v0.14.0/src/diffusers/pipelines/pipeline_utils.py#L1082"}}),Ut=new Y({props:{name:"enable_model_cpu_offload",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_model_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/v0.14.0/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L201"}}),Gt=new Y({props:{name:"enable_sequential_cpu_offload",anchor:"diffusers.StableDiffusionControlNetPipeline.enable_sequential_cpu_offload",parameters:[{name:"gpu_id",val:" = 0"}],source:"https://github.com/huggingface/diffusers/blob/v0.14.0/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py#L180"}}),{c(){$=n("meta"),A=c(),k=n("h1"),y=n("a"),N=n("span"),u(m.$$.fragment),D=c(),tn=n("span"),es=i("Text-to-Image Generation with ControlNet Conditioning"),Oa=c(),Z=n("h2"),re=n("a"),on=n("span"),u(He.$$.fragment),ts=c(),nn=n("span"),os=i("Overview"),Ua=c(),Ve=n("p"),Be=n("a"),ns=i("Adding Conditional Control to Text-to-Image Diffusion Models"),as=i(" by Lvmin Zhang and Maneesh Agrawala."),Ga=c(),Rt=n("p"),rs=i("Using the pretrained models we can provide control images (for example, a depth map) to control Stable Diffusion text-to-image generation so that it follows the structure of the depth image and fills in the details."),Fa=c(),Wt=n("p"),ss=i("The abstract of the paper is the following:"),za=c(),Ht=n("p"),an=n("em"),is=i("We present a neural network structure, ControlNet, to control pretrained large diffusion models to support additional input conditions. The ControlNet learns task-specific conditions in an end-to-end way, and the learning is robust even when the training dataset is small (< 50k). Moreover, training a ControlNet is as fast as fine-tuning a diffusion model, and the model can be trained on a personal devices. Alternatively, if powerful computation clusters are available, the model can scale to large amounts (millions to billions) of data. We report that large diffusion models like Stable Diffusion can be augmented with ControlNets to enable conditional inputs like edge maps, segmentation maps, keypoints, etc. This may enrich the methods to control large diffusion models and further facilitate related applications."),Ra=c(),se=n("p"),ls=i("This model was contributed by the amazing community contributor "),Ke=n("a"),cs=i("takuma104"),ds=i(" \u2764\uFE0F ."),Wa=c(),Vt=n("p"),fs=i("Resources:"),Ha=c(),ie=n("ul"),rn=n("li"),Ye=n("a"),ps=i("Paper"),ms=c(),sn=n("li"),Ze=n("a"),hs=i("Original Code"),Va=c(),J=n("h2"),le=n("a"),ln=n("span"),u(Je.$$.fragment),us=c(),cn=n("span"),gs=i("Available Pipelines:"),Ba=c(),ce=n("table"),dn=n("thead"),Q=n("tr"),fn=n("th"),_s=i("Pipeline"),vs=c(),pn=n("th"),bs=i("Tasks"),ws=c(),Bt=n("th"),ys=i("Demo"),Es=c(),mn=n("tbody"),X=n("tr"),hn=n("td"),Qe=n("a"),$s=i("StableDiffusionControlNetPipeline"),ks=c(),un=n("td"),gn=n("em"),Ps=i("Text-to-Image Generation with ControlNet Conditioning"),Cs=c(),Kt=n("td"),Xe=n("a"),Ds=i("Colab Example"),Ka=c(),ee=n("h2"),de=n("a"),_n=n("span"),u(et.$$.fragment),xs=c(),vn=n("span"),Ns=i("Usage example"),Ya=c(),fe=n("p"),Ts=i("In the following we give a simple example of how to use a "),bn=n("em"),Ss=i("ControlNet"),As=i(` checkpoint with Diffusers for inference.
The inference pipeline is the same for all pipelines:`),Za=c(),pe=n("ul"),wn=n("li"),yn=n("ol"),En=n("li"),Is=i("Take an image and run it through a pre-conditioning processor."),js=c(),$n=n("li"),Yt=n("ol"),tt=n("li"),Ms=i("Run the pre-processed image through the "),Zt=n("a"),Ls=i("StableDiffusionControlNetPipeline"),qs=i("."),Ja=c(),me=n("p"),Os=i("Let\u2019s have a look at a simple example using the "),ot=n("a"),Us=i("Canny Edge ControlNet"),Gs=i("."),Qa=c(),u(nt.$$.fragment),Xa=c(),Jt=n("p"),Qt=n("img"),er=c(),z=n("p"),Fs=i("Next, we process the image to get the canny image. This is step "),kn=n("em"),zs=i("1."),Rs=i(" - running the pre-conditioning processor. The pre-conditioning processor is different for every ControlNet. Please see the model cards of the "),Xt=n("a"),Ws=i("official checkpoints"),Hs=i(" for more information about other models."),tr=c(),eo=n("p"),Vs=i("First, we need to install opencv:"),or=c(),u(at.$$.fragment),nr=c(),to=n("p"),Bs=i("Next, let\u2019s also install all required Hugging Face libraries:"),ar=c(),u(rt.$$.fragment),rr=c(),oo=n("p"),Ks=i("Then we can retrieve the canny edges of the image."),sr=c(),u(st.$$.fragment),ir=c(),no=n("p"),Ys=i("Let\u2019s take a look at the processed image."),lr=c(),ao=n("p"),ro=n("img"),cr=c(),he=n("p"),Zs=i("Now, we load the official "),so=n("a"),Js=i("Stable Diffusion 1.5 Model"),Qs=i(" as well as the ControlNet for canny edges."),dr=c(),u(it.$$.fragment),fr=c(),ue=n("p"),Xs=i("To speed-up things and reduce memory, let\u2019s enable model offloading and use the fast "),io=n("a"),ei=i("UniPCMultistepScheduler"),ti=i("."),pr=c(),u(lt.$$.fragment),mr=c(),lo=n("p"),oi=i("Finally, we can run the pipeline:"),hr=c(),u(ct.$$.fragment),ur=c(),co=n("p"),ni=i("This should take only around 3-4 seconds on GPU (depending on hardware). The output image then looks as follows:"),gr=c(),fo=n("p"),po=n("img"),_r=c(),ge=n("p"),Pn=n("strong"),ai=i("Note"),ri=i(": To see how to run all other ControlNet checkpoints, please have a look at "),mo=n("a"),si=i("ControlNet with Stable Diffusion 1.5"),vr=c(),te=n("h2"),_e=n("a"),Cn=n("span"),u(dt.$$.fragment),ii=c(),Dn=n("span"),li=i("Available checkpoints"),br=c(),R=n("p"),ci=i("ControlNet requires a "),xn=n("em"),di=i("control image"),fi=i(" in addition to the text-to-image "),Nn=n("em"),pi=i("prompt"),mi=i(`.
Each pretrained model is trained using a different conditioning method that requires different images for conditioning the generated outputs. For example, Canny edge conditioning requires the control image to be the output of a Canny filter, while depth conditioning requires the control image to be a depth map. See the overview and image examples below to know more.`),wr=c(),ve=n("p"),hi=i("All checkpoints can be found under the authors\u2019 namespace "),ft=n("a"),ui=i("lllyasviel"),gi=i("."),yr=c(),oe=n("h3"),be=n("a"),Tn=n("span"),u(pt.$$.fragment),_i=c(),Sn=n("span"),vi=i("ControlNet with Stable Diffusion 1.5"),Er=c(),we=n("table"),An=n("thead"),I=n("tr"),In=n("th"),bi=i("Model Name"),wi=c(),jn=n("th"),yi=i("Control Image Overview"),Ei=c(),Mn=n("th"),$i=i("Control Image Example"),ki=c(),Ln=n("th"),Pi=i("Generated Image Example"),Ci=c(),P=n("tbody"),j=n("tr"),ye=n("td"),mt=n("a"),Di=i("lllyasviel/sd-controlnet-canny"),xi=n("br"),Ni=c(),qn=n("em"),Ti=i("Trained with canny edge detection"),Si=c(),On=n("td"),Ai=i("A monochrome image with white edges on a black background."),Ii=c(),Un=n("td"),ho=n("a"),Ee=n("img"),ji=c(),Gn=n("td"),uo=n("a"),go=n("img"),Mi=c(),M=n("tr"),$e=n("td"),ht=n("a"),Li=i("lllyasviel/sd-controlnet-depth"),qi=n("br"),Oi=c(),Fn=n("em"),Ui=i("Trained with Midas depth estimation"),Gi=c(),zn=n("td"),Fi=i("A grayscale image with black representing deep areas and white representing shallow areas."),zi=c(),Rn=n("td"),_o=n("a"),vo=n("img"),Ri=c(),Wn=n("td"),bo=n("a"),wo=n("img"),Wi=c(),L=n("tr"),ke=n("td"),ut=n("a"),Hi=i("lllyasviel/sd-controlnet-hed"),Vi=n("br"),Bi=c(),Hn=n("em"),Ki=i("Trained with HED edge detection (soft edge)"),Yi=c(),Vn=n("td"),Zi=i("A monochrome image with white soft edges on a black background."),Ji=c(),Bn=n("td"),yo=n("a"),Eo=n("img"),Qi=c(),Kn=n("td"),$o=n("a"),ko=n("img"),Xi=c(),q=n("tr"),Pe=n("td"),gt=n("a"),el=i("lllyasviel/sd-controlnet-mlsd"),tl=n("br"),ol=c(),Yn=n("em"),nl=i("Trained with M-LSD line detection"),al=c(),Zn=n("td"),rl=i("A monochrome image composed only of white straight lines on a black background."),sl=c(),Jn=n("td"),Po=n("a"),Co=n("img"),il=c(),Qn=n("td"),Do=n("a"),xo=n("img"),ll=c(),O=n("tr"),Ce=n("td"),_t=n("a"),cl=i("lllyasviel/sd-controlnet-normal"),dl=n("br"),fl=c(),Xn=n("em"),pl=i("Trained with normal map"),ml=c(),vt=n("td"),hl=i("A "),bt=n("a"),ul=i("normal mapped"),gl=i(" image."),_l=c(),ea=n("td"),No=n("a"),To=n("img"),vl=c(),ta=n("td"),So=n("a"),Ao=n("img"),bl=c(),U=n("tr"),De=n("td"),wt=n("a"),wl=i("lllyasviel/sd-controlnet-openpose"),yl=n("br"),El=c(),oa=n("em"),$l=i("Trained with OpenPose bone image"),kl=c(),yt=n("td"),Pl=i("A "),Et=n("a"),Cl=i("OpenPose bone"),Dl=i(" image."),xl=c(),na=n("td"),Io=n("a"),jo=n("img"),Nl=c(),aa=n("td"),Mo=n("a"),Lo=n("img"),Tl=c(),G=n("tr"),xe=n("td"),$t=n("a"),Sl=i("lllyasviel/sd-controlnet-scribble"),Al=n("br"),Il=c(),ra=n("em"),jl=i("Trained with human scribbles"),Ml=c(),sa=n("td"),Ll=i("A hand-drawn monochrome image with white outlines on a black background."),ql=c(),ia=n("td"),qo=n("a"),Oo=n("img"),Ol=c(),la=n("td"),Uo=n("a"),Go=n("img"),Ul=c(),F=n("tr"),kt=n("td"),Pt=n("a"),Gl=i("lllyasviel/sd-controlnet-seg"),Fl=n("br"),ca=n("em"),zl=i("Trained with semantic segmentation"),Rl=c(),Ct=n("td"),Wl=i("An "),Dt=n("a"),Hl=i("ADE20K"),Vl=i("\u2019s segmentation protocol image."),Bl=c(),da=n("td"),Fo=n("a"),zo=n("img"),Kl=c(),fa=n("td"),Ro=n("a"),Wo=n("img"),$r=c(),h=n("div"),u(xt.$$.fragment),Yl=c(),pa=n("p"),Zl=i("Pipeline for text-to-image generation using Stable Diffusion with ControlNet guidance."),Jl=c(),Nt=n("p"),Ql=i("This model inherits from "),Ho=n("a"),Xl=i("DiffusionPipeline"),ec=i(`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),tc=c(),W=n("div"),u(Tt.$$.fragment),oc=c(),ma=n("p"),nc=i("Function invoked when calling the pipeline for generation."),ac=c(),u(Ne.$$.fragment),rc=c(),H=n("div"),u(St.$$.fragment),sc=c(),ha=n("p"),ic=i("Enable sliced attention computation."),lc=c(),ua=n("p"),cc=i(`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),dc=c(),Te=n("div"),u(At.$$.fragment),fc=c(),It=n("p"),pc=i("Disable sliced attention computation. If "),ga=n("code"),mc=i("enable_attention_slicing"),hc=i(` was previously invoked, this method will go
back to computing attention in one step.`),uc=c(),V=n("div"),u(jt.$$.fragment),gc=c(),_a=n("p"),_c=i("Enable sliced VAE decoding."),vc=c(),va=n("p"),bc=i(`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),wc=c(),Se=n("div"),u(Mt.$$.fragment),yc=c(),Lt=n("p"),Ec=i("Disable sliced VAE decoding. If "),ba=n("code"),$c=i("enable_vae_slicing"),kc=i(` was previously invoked, this method will go back to
computing decoding in one step.`),Pc=c(),T=n("div"),u(qt.$$.fragment),Cc=c(),wa=n("p"),Dc=i("Enable memory efficient attention as implemented in xformers."),xc=c(),ya=n("p"),Nc=i(`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Tc=c(),Ea=n("p"),Sc=i(`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),Ac=c(),u(Ae.$$.fragment),Ic=c(),Ie=n("div"),u(Ot.$$.fragment),jc=c(),$a=n("p"),Mc=i("Disable memory efficient attention as implemented in xformers."),Lc=c(),je=n("div"),u(Ut.$$.fragment),qc=c(),S=n("p"),Oc=i(`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),ka=n("code"),Uc=i("enable_sequential_cpu_offload"),Gc=i(", this method moves one whole model at a time to the GPU when its "),Pa=n("code"),Fc=i("forward"),zc=i(`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Ca=n("code"),Rc=i("enable_sequential_cpu_offload"),Wc=i(", but performance is much better due to the iterative execution of the "),Da=n("code"),Hc=i("unet"),Vc=i("."),Bc=c(),Me=n("div"),u(Gt.$$.fragment),Kc=c(),ne=n("p"),Yc=i(`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae, controlnet, and safety checker have their state dicts saved to CPU and then are moved to a
`),xa=n("code"),Zc=i("torch.device('meta') and loaded to GPU only when their specific submodule has its "),Jc=i("forward"),Na=n("code"),Qc=i("method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),Xc=i("enable_model_cpu_offload`, but performance is lower."),this.h()},l(t){const f=dm('[data-svelte="svelte-1phssyn"]',document.head);$=a(f,"META",{name:!0,content:!0}),f.forEach(o),A=d(t),k=a(t,"H1",{class:!0});var Ft=r(k);y=a(Ft,"A",{id:!0,class:!0,href:!0});var Ta=r(y);N=a(Ta,"SPAN",{});var wd=r(N);g(m.$$.fragment,wd),wd.forEach(o),Ta.forEach(o),D=d(Ft),tn=a(Ft,"SPAN",{});var yd=r(tn);es=l(yd,"Text-to-Image Generation with ControlNet Conditioning"),yd.forEach(o),Ft.forEach(o),Oa=d(t),Z=a(t,"H2",{class:!0});var Pr=r(Z);re=a(Pr,"A",{id:!0,class:!0,href:!0});var Ed=r(re);on=a(Ed,"SPAN",{});var $d=r(on);g(He.$$.fragment,$d),$d.forEach(o),Ed.forEach(o),ts=d(Pr),nn=a(Pr,"SPAN",{});var kd=r(nn);os=l(kd,"Overview"),kd.forEach(o),Pr.forEach(o),Ua=d(t),Ve=a(t,"P",{});var ed=r(Ve);Be=a(ed,"A",{href:!0,rel:!0});var Pd=r(Be);ns=l(Pd,"Adding Conditional Control to Text-to-Image Diffusion Models"),Pd.forEach(o),as=l(ed," by Lvmin Zhang and Maneesh Agrawala."),ed.forEach(o),Ga=d(t),Rt=a(t,"P",{});var Cd=r(Rt);rs=l(Cd,"Using the pretrained models we can provide control images (for example, a depth map) to control Stable Diffusion text-to-image generation so that it follows the structure of the depth image and fills in the details."),Cd.forEach(o),Fa=d(t),Wt=a(t,"P",{});var Dd=r(Wt);ss=l(Dd,"The abstract of the paper is the following:"),Dd.forEach(o),za=d(t),Ht=a(t,"P",{});var xd=r(Ht);an=a(xd,"EM",{});var Nd=r(an);is=l(Nd,"We present a neural network structure, ControlNet, to control pretrained large diffusion models to support additional input conditions. The ControlNet learns task-specific conditions in an end-to-end way, and the learning is robust even when the training dataset is small (< 50k). Moreover, training a ControlNet is as fast as fine-tuning a diffusion model, and the model can be trained on a personal devices. Alternatively, if powerful computation clusters are available, the model can scale to large amounts (millions to billions) of data. We report that large diffusion models like Stable Diffusion can be augmented with ControlNets to enable conditional inputs like edge maps, segmentation maps, keypoints, etc. This may enrich the methods to control large diffusion models and further facilitate related applications."),Nd.forEach(o),xd.forEach(o),Ra=d(t),se=a(t,"P",{});var Cr=r(se);ls=l(Cr,"This model was contributed by the amazing community contributor "),Ke=a(Cr,"A",{href:!0,rel:!0});var Td=r(Ke);cs=l(Td,"takuma104"),Td.forEach(o),ds=l(Cr," \u2764\uFE0F ."),Cr.forEach(o),Wa=d(t),Vt=a(t,"P",{});var Sd=r(Vt);fs=l(Sd,"Resources:"),Sd.forEach(o),Ha=d(t),ie=a(t,"UL",{});var Dr=r(ie);rn=a(Dr,"LI",{});var Ad=r(rn);Ye=a(Ad,"A",{href:!0,rel:!0});var Id=r(Ye);ps=l(Id,"Paper"),Id.forEach(o),Ad.forEach(o),ms=d(Dr),sn=a(Dr,"LI",{});var jd=r(sn);Ze=a(jd,"A",{href:!0,rel:!0});var Md=r(Ze);hs=l(Md,"Original Code"),Md.forEach(o),jd.forEach(o),Dr.forEach(o),Va=d(t),J=a(t,"H2",{class:!0});var xr=r(J);le=a(xr,"A",{id:!0,class:!0,href:!0});var Ld=r(le);ln=a(Ld,"SPAN",{});var qd=r(ln);g(Je.$$.fragment,qd),qd.forEach(o),Ld.forEach(o),us=d(xr),cn=a(xr,"SPAN",{});var Od=r(cn);gs=l(Od,"Available Pipelines:"),Od.forEach(o),xr.forEach(o),Ba=d(t),ce=a(t,"TABLE",{});var Nr=r(ce);dn=a(Nr,"THEAD",{});var Ud=r(dn);Q=a(Ud,"TR",{});var Vo=r(Q);fn=a(Vo,"TH",{});var Gd=r(fn);_s=l(Gd,"Pipeline"),Gd.forEach(o),vs=d(Vo),pn=a(Vo,"TH",{});var Fd=r(pn);bs=l(Fd,"Tasks"),Fd.forEach(o),ws=d(Vo),Bt=a(Vo,"TH",{align:!0});var zd=r(Bt);ys=l(zd,"Demo"),zd.forEach(o),Vo.forEach(o),Ud.forEach(o),Es=d(Nr),mn=a(Nr,"TBODY",{});var Rd=r(mn);X=a(Rd,"TR",{});var Bo=r(X);hn=a(Bo,"TD",{});var Wd=r(hn);Qe=a(Wd,"A",{href:!0,rel:!0});var Hd=r(Qe);$s=l(Hd,"StableDiffusionControlNetPipeline"),Hd.forEach(o),Wd.forEach(o),ks=d(Bo),un=a(Bo,"TD",{});var Vd=r(un);gn=a(Vd,"EM",{});var Bd=r(gn);Ps=l(Bd,"Text-to-Image Generation with ControlNet Conditioning"),Bd.forEach(o),Vd.forEach(o),Cs=d(Bo),Kt=a(Bo,"TD",{align:!0});var Kd=r(Kt);Xe=a(Kd,"A",{href:!0,rel:!0});var Yd=r(Xe);Ds=l(Yd,"Colab Example"),Yd.forEach(o),Kd.forEach(o),Bo.forEach(o),Rd.forEach(o),Nr.forEach(o),Ka=d(t),ee=a(t,"H2",{class:!0});var Tr=r(ee);de=a(Tr,"A",{id:!0,class:!0,href:!0});var Zd=r(de);_n=a(Zd,"SPAN",{});var Jd=r(_n);g(et.$$.fragment,Jd),Jd.forEach(o),Zd.forEach(o),xs=d(Tr),vn=a(Tr,"SPAN",{});var Qd=r(vn);Ns=l(Qd,"Usage example"),Qd.forEach(o),Tr.forEach(o),Ya=d(t),fe=a(t,"P",{});var Sr=r(fe);Ts=l(Sr,"In the following we give a simple example of how to use a "),bn=a(Sr,"EM",{});var Xd=r(bn);Ss=l(Xd,"ControlNet"),Xd.forEach(o),As=l(Sr,` checkpoint with Diffusers for inference.
The inference pipeline is the same for all pipelines:`),Sr.forEach(o),Za=d(t),pe=a(t,"UL",{});var Ar=r(pe);wn=a(Ar,"LI",{});var ef=r(wn);yn=a(ef,"OL",{});var tf=r(yn);En=a(tf,"LI",{});var of=r(En);Is=l(of,"Take an image and run it through a pre-conditioning processor."),of.forEach(o),tf.forEach(o),ef.forEach(o),js=d(Ar),$n=a(Ar,"LI",{});var nf=r($n);Yt=a(nf,"OL",{start:!0});var af=r(Yt);tt=a(af,"LI",{});var Ir=r(tt);Ms=l(Ir,"Run the pre-processed image through the "),Zt=a(Ir,"A",{href:!0});var rf=r(Zt);Ls=l(rf,"StableDiffusionControlNetPipeline"),rf.forEach(o),qs=l(Ir,"."),Ir.forEach(o),af.forEach(o),nf.forEach(o),Ar.forEach(o),Ja=d(t),me=a(t,"P",{});var jr=r(me);Os=l(jr,"Let\u2019s have a look at a simple example using the "),ot=a(jr,"A",{href:!0,rel:!0});var sf=r(ot);Us=l(sf,"Canny Edge ControlNet"),sf.forEach(o),Gs=l(jr,"."),jr.forEach(o),Qa=d(t),g(nt.$$.fragment,t),Xa=d(t),Jt=a(t,"P",{});var lf=r(Jt);Qt=a(lf,"IMG",{src:!0,alt:!0}),lf.forEach(o),er=d(t),z=a(t,"P",{});var Ko=r(z);Fs=l(Ko,"Next, we process the image to get the canny image. This is step "),kn=a(Ko,"EM",{});var cf=r(kn);zs=l(cf,"1."),cf.forEach(o),Rs=l(Ko," - running the pre-conditioning processor. The pre-conditioning processor is different for every ControlNet. Please see the model cards of the "),Xt=a(Ko,"A",{href:!0});var df=r(Xt);Ws=l(df,"official checkpoints"),df.forEach(o),Hs=l(Ko," for more information about other models."),Ko.forEach(o),tr=d(t),eo=a(t,"P",{});var ff=r(eo);Vs=l(ff,"First, we need to install opencv:"),ff.forEach(o),or=d(t),g(at.$$.fragment,t),nr=d(t),to=a(t,"P",{});var pf=r(to);Bs=l(pf,"Next, let\u2019s also install all required Hugging Face libraries:"),pf.forEach(o),ar=d(t),g(rt.$$.fragment,t),rr=d(t),oo=a(t,"P",{});var mf=r(oo);Ks=l(mf,"Then we can retrieve the canny edges of the image."),mf.forEach(o),sr=d(t),g(st.$$.fragment,t),ir=d(t),no=a(t,"P",{});var hf=r(no);Ys=l(hf,"Let\u2019s take a look at the processed image."),hf.forEach(o),lr=d(t),ao=a(t,"P",{});var uf=r(ao);ro=a(uf,"IMG",{src:!0,alt:!0}),uf.forEach(o),cr=d(t),he=a(t,"P",{});var Mr=r(he);Zs=l(Mr,"Now, we load the official "),so=a(Mr,"A",{href:!0});var gf=r(so);Js=l(gf,"Stable Diffusion 1.5 Model"),gf.forEach(o),Qs=l(Mr," as well as the ControlNet for canny edges."),Mr.forEach(o),dr=d(t),g(it.$$.fragment,t),fr=d(t),ue=a(t,"P",{});var Lr=r(ue);Xs=l(Lr,"To speed-up things and reduce memory, let\u2019s enable model offloading and use the fast "),io=a(Lr,"A",{href:!0});var _f=r(io);ei=l(_f,"UniPCMultistepScheduler"),_f.forEach(o),ti=l(Lr,"."),Lr.forEach(o),pr=d(t),g(lt.$$.fragment,t),mr=d(t),lo=a(t,"P",{});var vf=r(lo);oi=l(vf,"Finally, we can run the pipeline:"),vf.forEach(o),hr=d(t),g(ct.$$.fragment,t),ur=d(t),co=a(t,"P",{});var bf=r(co);ni=l(bf,"This should take only around 3-4 seconds on GPU (depending on hardware). The output image then looks as follows:"),bf.forEach(o),gr=d(t),fo=a(t,"P",{});var wf=r(fo);po=a(wf,"IMG",{src:!0,alt:!0}),wf.forEach(o),_r=d(t),ge=a(t,"P",{});var qr=r(ge);Pn=a(qr,"STRONG",{});var yf=r(Pn);ai=l(yf,"Note"),yf.forEach(o),ri=l(qr,": To see how to run all other ControlNet checkpoints, please have a look at "),mo=a(qr,"A",{href:!0});var Ef=r(mo);si=l(Ef,"ControlNet with Stable Diffusion 1.5"),Ef.forEach(o),qr.forEach(o),vr=d(t),te=a(t,"H2",{class:!0});var Or=r(te);_e=a(Or,"A",{id:!0,class:!0,href:!0});var $f=r(_e);Cn=a($f,"SPAN",{});var kf=r(Cn);g(dt.$$.fragment,kf),kf.forEach(o),$f.forEach(o),ii=d(Or),Dn=a(Or,"SPAN",{});var Pf=r(Dn);li=l(Pf,"Available checkpoints"),Pf.forEach(o),Or.forEach(o),br=d(t),R=a(t,"P",{});var Yo=r(R);ci=l(Yo,"ControlNet requires a "),xn=a(Yo,"EM",{});var Cf=r(xn);di=l(Cf,"control image"),Cf.forEach(o),fi=l(Yo," in addition to the text-to-image "),Nn=a(Yo,"EM",{});var Df=r(Nn);pi=l(Df,"prompt"),Df.forEach(o),mi=l(Yo,`.
Each pretrained model is trained using a different conditioning method that requires different images for conditioning the generated outputs. For example, Canny edge conditioning requires the control image to be the output of a Canny filter, while depth conditioning requires the control image to be a depth map. See the overview and image examples below to know more.`),Yo.forEach(o),wr=d(t),ve=a(t,"P",{});var Ur=r(ve);hi=l(Ur,"All checkpoints can be found under the authors\u2019 namespace "),ft=a(Ur,"A",{href:!0,rel:!0});var xf=r(ft);ui=l(xf,"lllyasviel"),xf.forEach(o),gi=l(Ur,"."),Ur.forEach(o),yr=d(t),oe=a(t,"H3",{class:!0});var Gr=r(oe);be=a(Gr,"A",{id:!0,class:!0,href:!0});var Nf=r(be);Tn=a(Nf,"SPAN",{});var Tf=r(Tn);g(pt.$$.fragment,Tf),Tf.forEach(o),Nf.forEach(o),_i=d(Gr),Sn=a(Gr,"SPAN",{});var Sf=r(Sn);vi=l(Sf,"ControlNet with Stable Diffusion 1.5"),Sf.forEach(o),Gr.forEach(o),Er=d(t),we=a(t,"TABLE",{});var Fr=r(we);An=a(Fr,"THEAD",{});var Af=r(An);I=a(Af,"TR",{});var Le=r(I);In=a(Le,"TH",{});var If=r(In);bi=l(If,"Model Name"),If.forEach(o),wi=d(Le),jn=a(Le,"TH",{});var jf=r(jn);yi=l(jf,"Control Image Overview"),jf.forEach(o),Ei=d(Le),Mn=a(Le,"TH",{});var Mf=r(Mn);$i=l(Mf,"Control Image Example"),Mf.forEach(o),ki=d(Le),Ln=a(Le,"TH",{});var Lf=r(Ln);Pi=l(Lf,"Generated Image Example"),Lf.forEach(o),Le.forEach(o),Af.forEach(o),Ci=d(Fr),P=a(Fr,"TBODY",{});var x=r(P);j=a(x,"TR",{});var qe=r(j);ye=a(qe,"TD",{});var Sa=r(ye);mt=a(Sa,"A",{href:!0,rel:!0});var qf=r(mt);Di=l(qf,"lllyasviel/sd-controlnet-canny"),qf.forEach(o),xi=a(Sa,"BR",{}),Ni=d(Sa),qn=a(Sa,"EM",{});var Of=r(qn);Ti=l(Of,"Trained with canny edge detection"),Of.forEach(o),Sa.forEach(o),Si=d(qe),On=a(qe,"TD",{});var Uf=r(On);Ai=l(Uf,"A monochrome image with white edges on a black background."),Uf.forEach(o),Ii=d(qe),Un=a(qe,"TD",{});var Gf=r(Un);ho=a(Gf,"A",{href:!0});var Ff=r(ho);Ee=a(Ff,"IMG",{width:!0,style:!0,src:!0}),Ff.forEach(o),Gf.forEach(o),ji=d(qe),Gn=a(qe,"TD",{});var zf=r(Gn);uo=a(zf,"A",{href:!0});var Rf=r(uo);go=a(Rf,"IMG",{width:!0,src:!0}),Rf.forEach(o),zf.forEach(o),qe.forEach(o),Mi=d(x),M=a(x,"TR",{});var Oe=r(M);$e=a(Oe,"TD",{});var Aa=r($e);ht=a(Aa,"A",{href:!0,rel:!0});var Wf=r(ht);Li=l(Wf,"lllyasviel/sd-controlnet-depth"),Wf.forEach(o),qi=a(Aa,"BR",{}),Oi=d(Aa),Fn=a(Aa,"EM",{});var Hf=r(Fn);Ui=l(Hf,"Trained with Midas depth estimation"),Hf.forEach(o),Aa.forEach(o),Gi=d(Oe),zn=a(Oe,"TD",{});var Vf=r(zn);Fi=l(Vf,"A grayscale image with black representing deep areas and white representing shallow areas."),Vf.forEach(o),zi=d(Oe),Rn=a(Oe,"TD",{});var Bf=r(Rn);_o=a(Bf,"A",{href:!0});var Kf=r(_o);vo=a(Kf,"IMG",{width:!0,src:!0}),Kf.forEach(o),Bf.forEach(o),Ri=d(Oe),Wn=a(Oe,"TD",{});var Yf=r(Wn);bo=a(Yf,"A",{href:!0});var Zf=r(bo);wo=a(Zf,"IMG",{width:!0,src:!0}),Zf.forEach(o),Yf.forEach(o),Oe.forEach(o),Wi=d(x),L=a(x,"TR",{});var Ue=r(L);ke=a(Ue,"TD",{});var Ia=r(ke);ut=a(Ia,"A",{href:!0,rel:!0});var Jf=r(ut);Hi=l(Jf,"lllyasviel/sd-controlnet-hed"),Jf.forEach(o),Vi=a(Ia,"BR",{}),Bi=d(Ia),Hn=a(Ia,"EM",{});var Qf=r(Hn);Ki=l(Qf,"Trained with HED edge detection (soft edge)"),Qf.forEach(o),Ia.forEach(o),Yi=d(Ue),Vn=a(Ue,"TD",{});var Xf=r(Vn);Zi=l(Xf,"A monochrome image with white soft edges on a black background."),Xf.forEach(o),Ji=d(Ue),Bn=a(Ue,"TD",{});var ep=r(Bn);yo=a(ep,"A",{href:!0});var tp=r(yo);Eo=a(tp,"IMG",{width:!0,src:!0}),tp.forEach(o),ep.forEach(o),Qi=d(Ue),Kn=a(Ue,"TD",{});var op=r(Kn);$o=a(op,"A",{href:!0});var np=r($o);ko=a(np,"IMG",{width:!0,src:!0}),np.forEach(o),op.forEach(o),Ue.forEach(o),Xi=d(x),q=a(x,"TR",{});var Ge=r(q);Pe=a(Ge,"TD",{});var ja=r(Pe);gt=a(ja,"A",{href:!0,rel:!0});var ap=r(gt);el=l(ap,"lllyasviel/sd-controlnet-mlsd"),ap.forEach(o),tl=a(ja,"BR",{}),ol=d(ja),Yn=a(ja,"EM",{});var rp=r(Yn);nl=l(rp,"Trained with M-LSD line detection"),rp.forEach(o),ja.forEach(o),al=d(Ge),Zn=a(Ge,"TD",{});var sp=r(Zn);rl=l(sp,"A monochrome image composed only of white straight lines on a black background."),sp.forEach(o),sl=d(Ge),Jn=a(Ge,"TD",{});var ip=r(Jn);Po=a(ip,"A",{href:!0});var lp=r(Po);Co=a(lp,"IMG",{width:!0,src:!0}),lp.forEach(o),ip.forEach(o),il=d(Ge),Qn=a(Ge,"TD",{});var cp=r(Qn);Do=a(cp,"A",{href:!0});var dp=r(Do);xo=a(dp,"IMG",{width:!0,src:!0}),dp.forEach(o),cp.forEach(o),Ge.forEach(o),ll=d(x),O=a(x,"TR",{});var Fe=r(O);Ce=a(Fe,"TD",{});var Ma=r(Ce);_t=a(Ma,"A",{href:!0,rel:!0});var fp=r(_t);cl=l(fp,"lllyasviel/sd-controlnet-normal"),fp.forEach(o),dl=a(Ma,"BR",{}),fl=d(Ma),Xn=a(Ma,"EM",{});var pp=r(Xn);pl=l(pp,"Trained with normal map"),pp.forEach(o),Ma.forEach(o),ml=d(Fe),vt=a(Fe,"TD",{});var zr=r(vt);hl=l(zr,"A "),bt=a(zr,"A",{href:!0,rel:!0});var mp=r(bt);ul=l(mp,"normal mapped"),mp.forEach(o),gl=l(zr," image."),zr.forEach(o),_l=d(Fe),ea=a(Fe,"TD",{});var hp=r(ea);No=a(hp,"A",{href:!0});var up=r(No);To=a(up,"IMG",{width:!0,src:!0}),up.forEach(o),hp.forEach(o),vl=d(Fe),ta=a(Fe,"TD",{});var gp=r(ta);So=a(gp,"A",{href:!0});var _p=r(So);Ao=a(_p,"IMG",{width:!0,src:!0}),_p.forEach(o),gp.forEach(o),Fe.forEach(o),bl=d(x),U=a(x,"TR",{});var ze=r(U);De=a(ze,"TD",{});var La=r(De);wt=a(La,"A",{href:!0,rel:!0});var vp=r(wt);wl=l(vp,"lllyasviel/sd-controlnet-openpose"),vp.forEach(o),yl=a(La,"BR",{}),El=d(La),oa=a(La,"EM",{});var bp=r(oa);$l=l(bp,"Trained with OpenPose bone image"),bp.forEach(o),La.forEach(o),kl=d(ze),yt=a(ze,"TD",{});var Rr=r(yt);Pl=l(Rr,"A "),Et=a(Rr,"A",{href:!0,rel:!0});var wp=r(Et);Cl=l(wp,"OpenPose bone"),wp.forEach(o),Dl=l(Rr," image."),Rr.forEach(o),xl=d(ze),na=a(ze,"TD",{});var yp=r(na);Io=a(yp,"A",{href:!0});var Ep=r(Io);jo=a(Ep,"IMG",{width:!0,src:!0}),Ep.forEach(o),yp.forEach(o),Nl=d(ze),aa=a(ze,"TD",{});var $p=r(aa);Mo=a($p,"A",{href:!0});var kp=r(Mo);Lo=a(kp,"IMG",{width:!0,src:!0}),kp.forEach(o),$p.forEach(o),ze.forEach(o),Tl=d(x),G=a(x,"TR",{});var Re=r(G);xe=a(Re,"TD",{});var qa=r(xe);$t=a(qa,"A",{href:!0,rel:!0});var Pp=r($t);Sl=l(Pp,"lllyasviel/sd-controlnet-scribble"),Pp.forEach(o),Al=a(qa,"BR",{}),Il=d(qa),ra=a(qa,"EM",{});var Cp=r(ra);jl=l(Cp,"Trained with human scribbles"),Cp.forEach(o),qa.forEach(o),Ml=d(Re),sa=a(Re,"TD",{});var Dp=r(sa);Ll=l(Dp,"A hand-drawn monochrome image with white outlines on a black background."),Dp.forEach(o),ql=d(Re),ia=a(Re,"TD",{});var xp=r(ia);qo=a(xp,"A",{href:!0});var Np=r(qo);Oo=a(Np,"IMG",{width:!0,src:!0}),Np.forEach(o),xp.forEach(o),Ol=d(Re),la=a(Re,"TD",{});var Tp=r(la);Uo=a(Tp,"A",{href:!0});var Sp=r(Uo);Go=a(Sp,"IMG",{width:!0,src:!0}),Sp.forEach(o),Tp.forEach(o),Re.forEach(o),Ul=d(x),F=a(x,"TR",{});var We=r(F);kt=a(We,"TD",{});var Wr=r(kt);Pt=a(Wr,"A",{href:!0,rel:!0});var Ap=r(Pt);Gl=l(Ap,"lllyasviel/sd-controlnet-seg"),Ap.forEach(o),Fl=a(Wr,"BR",{}),ca=a(Wr,"EM",{});var Ip=r(ca);zl=l(Ip,"Trained with semantic segmentation"),Ip.forEach(o),Wr.forEach(o),Rl=d(We),Ct=a(We,"TD",{});var Hr=r(Ct);Wl=l(Hr,"An "),Dt=a(Hr,"A",{href:!0,rel:!0});var jp=r(Dt);Hl=l(jp,"ADE20K"),jp.forEach(o),Vl=l(Hr,"\u2019s segmentation protocol image."),Hr.forEach(o),Bl=d(We),da=a(We,"TD",{});var Mp=r(da);Fo=a(Mp,"A",{href:!0});var Lp=r(Fo);zo=a(Lp,"IMG",{width:!0,src:!0}),Lp.forEach(o),Mp.forEach(o),Kl=d(We),fa=a(We,"TD",{});var qp=r(fa);Ro=a(qp,"A",{href:!0});var Op=r(Ro);Wo=a(Op,"IMG",{width:!0,src:!0}),Op.forEach(o),qp.forEach(o),We.forEach(o),x.forEach(o),Fr.forEach(o),$r=d(t),h=a(t,"DIV",{class:!0});var E=r(h);g(xt.$$.fragment,E),Yl=d(E),pa=a(E,"P",{});var Up=r(pa);Zl=l(Up,"Pipeline for text-to-image generation using Stable Diffusion with ControlNet guidance."),Up.forEach(o),Jl=d(E),Nt=a(E,"P",{});var Vr=r(Nt);Ql=l(Vr,"This model inherits from "),Ho=a(Vr,"A",{href:!0});var Gp=r(Ho);Xl=l(Gp,"DiffusionPipeline"),Gp.forEach(o),ec=l(Vr,`. Check the superclass documentation for the generic methods the
library implements for all the pipelines (such as downloading or saving, running on a particular device, etc.)`),Vr.forEach(o),tc=d(E),W=a(E,"DIV",{class:!0});var Zo=r(W);g(Tt.$$.fragment,Zo),oc=d(Zo),ma=a(Zo,"P",{});var Fp=r(ma);nc=l(Fp,"Function invoked when calling the pipeline for generation."),Fp.forEach(o),ac=d(Zo),g(Ne.$$.fragment,Zo),Zo.forEach(o),rc=d(E),H=a(E,"DIV",{class:!0});var Jo=r(H);g(St.$$.fragment,Jo),sc=d(Jo),ha=a(Jo,"P",{});var zp=r(ha);ic=l(zp,"Enable sliced attention computation."),zp.forEach(o),lc=d(Jo),ua=a(Jo,"P",{});var Rp=r(ua);cc=l(Rp,`When this option is enabled, the attention module will split the input tensor in slices, to compute attention
in several steps. This is useful to save some memory in exchange for a small speed decrease.`),Rp.forEach(o),Jo.forEach(o),dc=d(E),Te=a(E,"DIV",{class:!0});var Br=r(Te);g(At.$$.fragment,Br),fc=d(Br),It=a(Br,"P",{});var Kr=r(It);pc=l(Kr,"Disable sliced attention computation. If "),ga=a(Kr,"CODE",{});var Wp=r(ga);mc=l(Wp,"enable_attention_slicing"),Wp.forEach(o),hc=l(Kr,` was previously invoked, this method will go
back to computing attention in one step.`),Kr.forEach(o),Br.forEach(o),uc=d(E),V=a(E,"DIV",{class:!0});var Qo=r(V);g(jt.$$.fragment,Qo),gc=d(Qo),_a=a(Qo,"P",{});var Hp=r(_a);_c=l(Hp,"Enable sliced VAE decoding."),Hp.forEach(o),vc=d(Qo),va=a(Qo,"P",{});var Vp=r(va);bc=l(Vp,`When this option is enabled, the VAE will split the input tensor in slices to compute decoding in several
steps. This is useful to save some memory and allow larger batch sizes.`),Vp.forEach(o),Qo.forEach(o),wc=d(E),Se=a(E,"DIV",{class:!0});var Yr=r(Se);g(Mt.$$.fragment,Yr),yc=d(Yr),Lt=a(Yr,"P",{});var Zr=r(Lt);Ec=l(Zr,"Disable sliced VAE decoding. If "),ba=a(Zr,"CODE",{});var Bp=r(ba);$c=l(Bp,"enable_vae_slicing"),Bp.forEach(o),kc=l(Zr,` was previously invoked, this method will go back to
computing decoding in one step.`),Zr.forEach(o),Yr.forEach(o),Pc=d(E),T=a(E,"DIV",{class:!0});var B=r(T);g(qt.$$.fragment,B),Cc=d(B),wa=a(B,"P",{});var Kp=r(wa);Dc=l(Kp,"Enable memory efficient attention as implemented in xformers."),Kp.forEach(o),xc=d(B),ya=a(B,"P",{});var Yp=r(ya);Nc=l(Yp,`When this option is enabled, you should observe lower GPU memory usage and a potential speed up at inference
time. Speed up at training time is not guaranteed.`),Yp.forEach(o),Tc=d(B),Ea=a(B,"P",{});var Zp=r(Ea);Sc=l(Zp,`Warning: When Memory Efficient Attention and Sliced attention are both enabled, the Memory Efficient Attention
is used.`),Zp.forEach(o),Ac=d(B),g(Ae.$$.fragment,B),B.forEach(o),Ic=d(E),Ie=a(E,"DIV",{class:!0});var Jr=r(Ie);g(Ot.$$.fragment,Jr),jc=d(Jr),$a=a(Jr,"P",{});var Jp=r($a);Mc=l(Jp,"Disable memory efficient attention as implemented in xformers."),Jp.forEach(o),Jr.forEach(o),Lc=d(E),je=a(E,"DIV",{class:!0});var Qr=r(je);g(Ut.$$.fragment,Qr),qc=d(Qr),S=a(Qr,"P",{});var K=r(S);Oc=l(K,`Offloads all models to CPU using accelerate, reducing memory usage with a low impact on performance. Compared
to `),ka=a(K,"CODE",{});var Qp=r(ka);Uc=l(Qp,"enable_sequential_cpu_offload"),Qp.forEach(o),Gc=l(K,", this method moves one whole model at a time to the GPU when its "),Pa=a(K,"CODE",{});var Xp=r(Pa);Fc=l(Xp,"forward"),Xp.forEach(o),zc=l(K,`
method is called, and the model remains in GPU until the next model runs. Memory savings are lower than with
`),Ca=a(K,"CODE",{});var em=r(Ca);Rc=l(em,"enable_sequential_cpu_offload"),em.forEach(o),Wc=l(K,", but performance is much better due to the iterative execution of the "),Da=a(K,"CODE",{});var tm=r(Da);Hc=l(tm,"unet"),tm.forEach(o),Vc=l(K,"."),K.forEach(o),Qr.forEach(o),Bc=d(E),Me=a(E,"DIV",{class:!0});var Xr=r(Me);g(Gt.$$.fragment,Xr),Kc=d(Xr),ne=a(Xr,"P",{});var Xo=r(ne);Yc=l(Xo,`Offloads all models to CPU using accelerate, significantly reducing memory usage. When called, unet,
text_encoder, vae, controlnet, and safety checker have their state dicts saved to CPU and then are moved to a
`),xa=a(Xo,"CODE",{});var om=r(xa);Zc=l(om,"torch.device('meta') and loaded to GPU only when their specific submodule has its "),om.forEach(o),Jc=l(Xo,"forward"),Na=a(Xo,"CODE",{});var nm=r(Na);Qc=l(nm,"method called. Note that offloading happens on a submodule basis. Memory savings are higher than with"),nm.forEach(o),Xc=l(Xo,"enable_model_cpu_offload`, but performance is lower."),Xo.forEach(o),Xr.forEach(o),E.forEach(o),this.h()},h(){s($,"name","hf:doc:metadata"),s($,"content",JSON.stringify(um)),s(y,"id","texttoimage-generation-with-controlnet-conditioning"),s(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(y,"href","#texttoimage-generation-with-controlnet-conditioning"),s(k,"class","relative group"),s(re,"id","overview"),s(re,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(re,"href","#overview"),s(Z,"class","relative group"),s(Be,"href","https://arxiv.org/abs/2302.05543"),s(Be,"rel","nofollow"),s(Ke,"href","https://huggingface.co/takuma104"),s(Ke,"rel","nofollow"),s(Ye,"href","https://arxiv.org/abs/2302.05543"),s(Ye,"rel","nofollow"),s(Ze,"href","https://github.com/lllyasviel/ControlNet"),s(Ze,"rel","nofollow"),s(le,"id","available-pipelines"),s(le,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(le,"href","#available-pipelines"),s(J,"class","relative group"),s(Bt,"align","center"),s(Qe,"href","https://github.com/huggingface/diffusers/blob/main/src/diffusers/pipelines/stable_diffusion/pipeline_stable_diffusion_controlnet.py"),s(Qe,"rel","nofollow"),s(Xe,"href","https://colab.research.google.com/github/huggingface/notebooks/blob/main/diffusers/controlnet.ipynb"),s(Xe,"rel","nofollow"),s(Kt,"align","center"),s(de,"id","usage-example"),s(de,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(de,"href","#usage-example"),s(ee,"class","relative group"),s(Zt,"href","/docs/diffusers/v0.14.0/en/api/pipelines/stable_diffusion/controlnet#diffusers.StableDiffusionControlNetPipeline"),s(Yt,"start","2"),s(ot,"href","https://huggingface.co/lllyasviel/sd-controlnet-canny"),s(ot,"rel","nofollow"),C(Qt.src,td="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/input_image_vermeer.png")||s(Qt,"src",td),s(Qt,"alt","img"),s(Xt,"href","#controlnet-with-stable-diffusion-1.5"),C(ro.src,od="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/vermeer_canny_edged.png")||s(ro,"src",od),s(ro,"alt","img"),s(so,"href","runwayml/stable-diffusion-v1-5"),s(io,"href","/docs/diffusers/v0.14.0/en/api/schedulers/unipc#diffusers.UniPCMultistepScheduler"),C(po.src,nd="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/diffusers/vermeer_disco_dancing.png")||s(po,"src",nd),s(po,"alt","img"),s(mo,"href","#controlnet-with-stable-diffusion-1.5"),s(_e,"id","available-checkpoints"),s(_e,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(_e,"href","#available-checkpoints"),s(te,"class","relative group"),s(ft,"href","https://huggingface.co/lllyasviel"),s(ft,"rel","nofollow"),s(be,"id","diffusers.StableDiffusionControlNetPipeline"),s(be,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),s(be,"href","#diffusers.StableDiffusionControlNetPipeline"),s(oe,"class","relative group"),s(mt,"href","https://huggingface.co/lllyasviel/sd-controlnet-canny"),s(mt,"rel","nofollow"),s(Ee,"width","64"),am(Ee,"margin","0"),am(Ee,"padding","0"),C(Ee.src,ad="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_bird_canny.png")||s(Ee,"src",ad),s(ho,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_bird_canny.png"),s(go,"width","64"),C(go.src,rd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_canny_1.png")||s(go,"src",rd),s(uo,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_canny_1.png"),s(ht,"href","https://huggingface.co/lllyasviel/sd-controlnet-depth"),s(ht,"rel","nofollow"),s(vo,"width","64"),C(vo.src,sd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_vermeer_depth.png")||s(vo,"src",sd),s(_o,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_vermeer_depth.png"),s(wo,"width","64"),C(wo.src,id="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_depth_2.png")||s(wo,"src",id),s(bo,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_depth_2.png"),s(ut,"href","https://huggingface.co/lllyasviel/sd-controlnet-hed"),s(ut,"rel","nofollow"),s(Eo,"width","64"),C(Eo.src,ld="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_bird_hed.png")||s(Eo,"src",ld),s(yo,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_bird_hed.png"),s(ko,"width","64"),C(ko.src,cd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_hed_1.png")||s(ko,"src",cd),s($o,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_bird_hed_1.png"),s(gt,"href","https://huggingface.co/lllyasviel/sd-controlnet-mlsd"),s(gt,"rel","nofollow"),s(Co,"width","64"),C(Co.src,dd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_room_mlsd.png")||s(Co,"src",dd),s(Po,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_room_mlsd.png"),s(xo,"width","64"),C(xo.src,fd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_mlsd_0.png")||s(xo,"src",fd),s(Do,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_mlsd_0.png"),s(_t,"href","https://huggingface.co/lllyasviel/sd-controlnet-normal"),s(_t,"rel","nofollow"),s(bt,"href","https://en.wikipedia.org/wiki/Normal_mapping"),s(bt,"rel","nofollow"),s(To,"width","64"),C(To.src,pd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_human_normal.png")||s(To,"src",pd),s(No,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_human_normal.png"),s(Ao,"width","64"),C(Ao.src,md="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_normal_1.png")||s(Ao,"src",md),s(So,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_normal_1.png"),s(wt,"href","https://huggingface.co/lllyasviel/sd-controlnet_openpose"),s(wt,"rel","nofollow"),s(Et,"href","https://github.com/CMU-Perceptual-Computing-Lab/openpose"),s(Et,"rel","nofollow"),s(jo,"width","64"),C(jo.src,hd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_human_openpose.png")||s(jo,"src",hd),s(Io,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_human_openpose.png"),s(Lo,"width","64"),C(Lo.src,ud="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_openpose_0.png")||s(Lo,"src",ud),s(Mo,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_human_openpose_0.png"),s($t,"href","https://huggingface.co/lllyasviel/sd-controlnet_scribble"),s($t,"rel","nofollow"),s(Oo,"width","64"),C(Oo.src,gd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_vermeer_scribble.png")||s(Oo,"src",gd),s(qo,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_vermeer_scribble.png"),s(Go,"width","64"),C(Go.src,_d="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_scribble_0.png")||s(Go,"src",_d),s(Uo,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_vermeer_scribble_0.png"),s(Pt,"href","https://huggingface.co/lllyasviel/sd-controlnet_seg"),s(Pt,"rel","nofollow"),s(Dt,"href","https://groups.csail.mit.edu/vision/datasets/ADE20K/"),s(Dt,"rel","nofollow"),s(zo,"width","64"),C(zo.src,vd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/control_images/converted/control_room_seg.png")||s(zo,"src",vd),s(Fo,"href","https://huggingface.co/takuma104/controlnet_dev/blob/main/gen_compare/control_images/converted/control_room_seg.png"),s(Wo,"width","64"),C(Wo.src,bd="https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_seg_1.png")||s(Wo,"src",bd),s(Ro,"href","https://huggingface.co/takuma104/controlnet_dev/resolve/main/gen_compare/output_images/diffusers/output_room_seg_1.png"),s(Ho,"href","/docs/diffusers/v0.14.0/en/api/diffusion_pipeline#diffusers.DiffusionPipeline"),s(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(Te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(Se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(Ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(je,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(Me,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),s(h,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(t,f){e(document.head,$),p(t,A,f),p(t,k,f),e(k,y),e(y,N),_(m,N,null),e(k,D),e(k,tn),e(tn,es),p(t,Oa,f),p(t,Z,f),e(Z,re),e(re,on),_(He,on,null),e(Z,ts),e(Z,nn),e(nn,os),p(t,Ua,f),p(t,Ve,f),e(Ve,Be),e(Be,ns),e(Ve,as),p(t,Ga,f),p(t,Rt,f),e(Rt,rs),p(t,Fa,f),p(t,Wt,f),e(Wt,ss),p(t,za,f),p(t,Ht,f),e(Ht,an),e(an,is),p(t,Ra,f),p(t,se,f),e(se,ls),e(se,Ke),e(Ke,cs),e(se,ds),p(t,Wa,f),p(t,Vt,f),e(Vt,fs),p(t,Ha,f),p(t,ie,f),e(ie,rn),e(rn,Ye),e(Ye,ps),e(ie,ms),e(ie,sn),e(sn,Ze),e(Ze,hs),p(t,Va,f),p(t,J,f),e(J,le),e(le,ln),_(Je,ln,null),e(J,us),e(J,cn),e(cn,gs),p(t,Ba,f),p(t,ce,f),e(ce,dn),e(dn,Q),e(Q,fn),e(fn,_s),e(Q,vs),e(Q,pn),e(pn,bs),e(Q,ws),e(Q,Bt),e(Bt,ys),e(ce,Es),e(ce,mn),e(mn,X),e(X,hn),e(hn,Qe),e(Qe,$s),e(X,ks),e(X,un),e(un,gn),e(gn,Ps),e(X,Cs),e(X,Kt),e(Kt,Xe),e(Xe,Ds),p(t,Ka,f),p(t,ee,f),e(ee,de),e(de,_n),_(et,_n,null),e(ee,xs),e(ee,vn),e(vn,Ns),p(t,Ya,f),p(t,fe,f),e(fe,Ts),e(fe,bn),e(bn,Ss),e(fe,As),p(t,Za,f),p(t,pe,f),e(pe,wn),e(wn,yn),e(yn,En),e(En,Is),e(pe,js),e(pe,$n),e($n,Yt),e(Yt,tt),e(tt,Ms),e(tt,Zt),e(Zt,Ls),e(tt,qs),p(t,Ja,f),p(t,me,f),e(me,Os),e(me,ot),e(ot,Us),e(me,Gs),p(t,Qa,f),_(nt,t,f),p(t,Xa,f),p(t,Jt,f),e(Jt,Qt),p(t,er,f),p(t,z,f),e(z,Fs),e(z,kn),e(kn,zs),e(z,Rs),e(z,Xt),e(Xt,Ws),e(z,Hs),p(t,tr,f),p(t,eo,f),e(eo,Vs),p(t,or,f),_(at,t,f),p(t,nr,f),p(t,to,f),e(to,Bs),p(t,ar,f),_(rt,t,f),p(t,rr,f),p(t,oo,f),e(oo,Ks),p(t,sr,f),_(st,t,f),p(t,ir,f),p(t,no,f),e(no,Ys),p(t,lr,f),p(t,ao,f),e(ao,ro),p(t,cr,f),p(t,he,f),e(he,Zs),e(he,so),e(so,Js),e(he,Qs),p(t,dr,f),_(it,t,f),p(t,fr,f),p(t,ue,f),e(ue,Xs),e(ue,io),e(io,ei),e(ue,ti),p(t,pr,f),_(lt,t,f),p(t,mr,f),p(t,lo,f),e(lo,oi),p(t,hr,f),_(ct,t,f),p(t,ur,f),p(t,co,f),e(co,ni),p(t,gr,f),p(t,fo,f),e(fo,po),p(t,_r,f),p(t,ge,f),e(ge,Pn),e(Pn,ai),e(ge,ri),e(ge,mo),e(mo,si),p(t,vr,f),p(t,te,f),e(te,_e),e(_e,Cn),_(dt,Cn,null),e(te,ii),e(te,Dn),e(Dn,li),p(t,br,f),p(t,R,f),e(R,ci),e(R,xn),e(xn,di),e(R,fi),e(R,Nn),e(Nn,pi),e(R,mi),p(t,wr,f),p(t,ve,f),e(ve,hi),e(ve,ft),e(ft,ui),e(ve,gi),p(t,yr,f),p(t,oe,f),e(oe,be),e(be,Tn),_(pt,Tn,null),e(oe,_i),e(oe,Sn),e(Sn,vi),p(t,Er,f),p(t,we,f),e(we,An),e(An,I),e(I,In),e(In,bi),e(I,wi),e(I,jn),e(jn,yi),e(I,Ei),e(I,Mn),e(Mn,$i),e(I,ki),e(I,Ln),e(Ln,Pi),e(we,Ci),e(we,P),e(P,j),e(j,ye),e(ye,mt),e(mt,Di),e(ye,xi),e(ye,Ni),e(ye,qn),e(qn,Ti),e(j,Si),e(j,On),e(On,Ai),e(j,Ii),e(j,Un),e(Un,ho),e(ho,Ee),e(j,ji),e(j,Gn),e(Gn,uo),e(uo,go),e(P,Mi),e(P,M),e(M,$e),e($e,ht),e(ht,Li),e($e,qi),e($e,Oi),e($e,Fn),e(Fn,Ui),e(M,Gi),e(M,zn),e(zn,Fi),e(M,zi),e(M,Rn),e(Rn,_o),e(_o,vo),e(M,Ri),e(M,Wn),e(Wn,bo),e(bo,wo),e(P,Wi),e(P,L),e(L,ke),e(ke,ut),e(ut,Hi),e(ke,Vi),e(ke,Bi),e(ke,Hn),e(Hn,Ki),e(L,Yi),e(L,Vn),e(Vn,Zi),e(L,Ji),e(L,Bn),e(Bn,yo),e(yo,Eo),e(L,Qi),e(L,Kn),e(Kn,$o),e($o,ko),e(P,Xi),e(P,q),e(q,Pe),e(Pe,gt),e(gt,el),e(Pe,tl),e(Pe,ol),e(Pe,Yn),e(Yn,nl),e(q,al),e(q,Zn),e(Zn,rl),e(q,sl),e(q,Jn),e(Jn,Po),e(Po,Co),e(q,il),e(q,Qn),e(Qn,Do),e(Do,xo),e(P,ll),e(P,O),e(O,Ce),e(Ce,_t),e(_t,cl),e(Ce,dl),e(Ce,fl),e(Ce,Xn),e(Xn,pl),e(O,ml),e(O,vt),e(vt,hl),e(vt,bt),e(bt,ul),e(vt,gl),e(O,_l),e(O,ea),e(ea,No),e(No,To),e(O,vl),e(O,ta),e(ta,So),e(So,Ao),e(P,bl),e(P,U),e(U,De),e(De,wt),e(wt,wl),e(De,yl),e(De,El),e(De,oa),e(oa,$l),e(U,kl),e(U,yt),e(yt,Pl),e(yt,Et),e(Et,Cl),e(yt,Dl),e(U,xl),e(U,na),e(na,Io),e(Io,jo),e(U,Nl),e(U,aa),e(aa,Mo),e(Mo,Lo),e(P,Tl),e(P,G),e(G,xe),e(xe,$t),e($t,Sl),e(xe,Al),e(xe,Il),e(xe,ra),e(ra,jl),e(G,Ml),e(G,sa),e(sa,Ll),e(G,ql),e(G,ia),e(ia,qo),e(qo,Oo),e(G,Ol),e(G,la),e(la,Uo),e(Uo,Go),e(P,Ul),e(P,F),e(F,kt),e(kt,Pt),e(Pt,Gl),e(kt,Fl),e(kt,ca),e(ca,zl),e(F,Rl),e(F,Ct),e(Ct,Wl),e(Ct,Dt),e(Dt,Hl),e(Ct,Vl),e(F,Bl),e(F,da),e(da,Fo),e(Fo,zo),e(F,Kl),e(F,fa),e(fa,Ro),e(Ro,Wo),p(t,$r,f),p(t,h,f),_(xt,h,null),e(h,Yl),e(h,pa),e(pa,Zl),e(h,Jl),e(h,Nt),e(Nt,Ql),e(Nt,Ho),e(Ho,Xl),e(Nt,ec),e(h,tc),e(h,W),_(Tt,W,null),e(W,oc),e(W,ma),e(ma,nc),e(W,ac),_(Ne,W,null),e(h,rc),e(h,H),_(St,H,null),e(H,sc),e(H,ha),e(ha,ic),e(H,lc),e(H,ua),e(ua,cc),e(h,dc),e(h,Te),_(At,Te,null),e(Te,fc),e(Te,It),e(It,pc),e(It,ga),e(ga,mc),e(It,hc),e(h,uc),e(h,V),_(jt,V,null),e(V,gc),e(V,_a),e(_a,_c),e(V,vc),e(V,va),e(va,bc),e(h,wc),e(h,Se),_(Mt,Se,null),e(Se,yc),e(Se,Lt),e(Lt,Ec),e(Lt,ba),e(ba,$c),e(Lt,kc),e(h,Pc),e(h,T),_(qt,T,null),e(T,Cc),e(T,wa),e(wa,Dc),e(T,xc),e(T,ya),e(ya,Nc),e(T,Tc),e(T,Ea),e(Ea,Sc),e(T,Ac),_(Ae,T,null),e(h,Ic),e(h,Ie),_(Ot,Ie,null),e(Ie,jc),e(Ie,$a),e($a,Mc),e(h,Lc),e(h,je),_(Ut,je,null),e(je,qc),e(je,S),e(S,Oc),e(S,ka),e(ka,Uc),e(S,Gc),e(S,Pa),e(Pa,Fc),e(S,zc),e(S,Ca),e(Ca,Rc),e(S,Wc),e(S,Da),e(Da,Hc),e(S,Vc),e(h,Bc),e(h,Me),_(Gt,Me,null),e(Me,Kc),e(Me,ne),e(ne,Yc),e(ne,xa),e(xa,Zc),e(ne,Jc),e(ne,Na),e(Na,Qc),e(ne,Xc),kr=!0},p(t,[f]){const Ft={};f&2&&(Ft.$$scope={dirty:f,ctx:t}),Ne.$set(Ft);const Ta={};f&2&&(Ta.$$scope={dirty:f,ctx:t}),Ae.$set(Ta)},i(t){kr||(v(m.$$.fragment,t),v(He.$$.fragment,t),v(Je.$$.fragment,t),v(et.$$.fragment,t),v(nt.$$.fragment,t),v(at.$$.fragment,t),v(rt.$$.fragment,t),v(st.$$.fragment,t),v(it.$$.fragment,t),v(lt.$$.fragment,t),v(ct.$$.fragment,t),v(dt.$$.fragment,t),v(pt.$$.fragment,t),v(xt.$$.fragment,t),v(Tt.$$.fragment,t),v(Ne.$$.fragment,t),v(St.$$.fragment,t),v(At.$$.fragment,t),v(jt.$$.fragment,t),v(Mt.$$.fragment,t),v(qt.$$.fragment,t),v(Ae.$$.fragment,t),v(Ot.$$.fragment,t),v(Ut.$$.fragment,t),v(Gt.$$.fragment,t),kr=!0)},o(t){b(m.$$.fragment,t),b(He.$$.fragment,t),b(Je.$$.fragment,t),b(et.$$.fragment,t),b(nt.$$.fragment,t),b(at.$$.fragment,t),b(rt.$$.fragment,t),b(st.$$.fragment,t),b(it.$$.fragment,t),b(lt.$$.fragment,t),b(ct.$$.fragment,t),b(dt.$$.fragment,t),b(pt.$$.fragment,t),b(xt.$$.fragment,t),b(Tt.$$.fragment,t),b(Ne.$$.fragment,t),b(St.$$.fragment,t),b(At.$$.fragment,t),b(jt.$$.fragment,t),b(Mt.$$.fragment,t),b(qt.$$.fragment,t),b(Ae.$$.fragment,t),b(Ot.$$.fragment,t),b(Ut.$$.fragment,t),b(Gt.$$.fragment,t),kr=!1},d(t){o($),t&&o(A),t&&o(k),w(m),t&&o(Oa),t&&o(Z),w(He),t&&o(Ua),t&&o(Ve),t&&o(Ga),t&&o(Rt),t&&o(Fa),t&&o(Wt),t&&o(za),t&&o(Ht),t&&o(Ra),t&&o(se),t&&o(Wa),t&&o(Vt),t&&o(Ha),t&&o(ie),t&&o(Va),t&&o(J),w(Je),t&&o(Ba),t&&o(ce),t&&o(Ka),t&&o(ee),w(et),t&&o(Ya),t&&o(fe),t&&o(Za),t&&o(pe),t&&o(Ja),t&&o(me),t&&o(Qa),w(nt,t),t&&o(Xa),t&&o(Jt),t&&o(er),t&&o(z),t&&o(tr),t&&o(eo),t&&o(or),w(at,t),t&&o(nr),t&&o(to),t&&o(ar),w(rt,t),t&&o(rr),t&&o(oo),t&&o(sr),w(st,t),t&&o(ir),t&&o(no),t&&o(lr),t&&o(ao),t&&o(cr),t&&o(he),t&&o(dr),w(it,t),t&&o(fr),t&&o(ue),t&&o(pr),w(lt,t),t&&o(mr),t&&o(lo),t&&o(hr),w(ct,t),t&&o(ur),t&&o(co),t&&o(gr),t&&o(fo),t&&o(_r),t&&o(ge),t&&o(vr),t&&o(te),w(dt),t&&o(br),t&&o(R),t&&o(wr),t&&o(ve),t&&o(yr),t&&o(oe),w(pt),t&&o(Er),t&&o(we),t&&o($r),t&&o(h),w(xt),w(Tt),w(Ne),w(St),w(At),w(jt),w(Mt),w(qt),w(Ae),w(Ot),w(Ut),w(Gt)}}}const um={local:"texttoimage-generation-with-controlnet-conditioning",sections:[{local:"overview",title:"Overview"},{local:"available-pipelines",title:"Available Pipelines:"},{local:"usage-example",title:"Usage example"},{local:"available-checkpoints",sections:[{local:"diffusers.StableDiffusionControlNetPipeline",title:"ControlNet with Stable Diffusion 1.5"}],title:"Available checkpoints"}],title:"Text-to-Image Generation with ControlNet Conditioning"};function gm(zt){return fm(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Em extends im{constructor($){super();lm(this,$,gm,hm,cm,{})}}export{Em as default,um as metadata};
